/*
Copyright 2018 The CDI Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1beta1

import (
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/listers"
	"k8s.io/client-go/tools/cache"
	v1beta1 "kubevirt.io/containerized-data-importer-api/pkg/apis/forklift/v1beta1"
)

// OpenstackVolumePopulatorLister helps list OpenstackVolumePopulators.
// All objects returned here must be treated as read-only.
type OpenstackVolumePopulatorLister interface {
	// List lists all OpenstackVolumePopulators in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta1.OpenstackVolumePopulator, err error)
	// OpenstackVolumePopulators returns an object that can list and get OpenstackVolumePopulators.
	OpenstackVolumePopulators(namespace string) OpenstackVolumePopulatorNamespaceLister
	OpenstackVolumePopulatorListerExpansion
}

// openstackVolumePopulatorLister implements the OpenstackVolumePopulatorLister interface.
type openstackVolumePopulatorLister struct {
	listers.ResourceIndexer[*v1beta1.OpenstackVolumePopulator]
}

// NewOpenstackVolumePopulatorLister returns a new OpenstackVolumePopulatorLister.
func NewOpenstackVolumePopulatorLister(indexer cache.Indexer) OpenstackVolumePopulatorLister {
	return &openstackVolumePopulatorLister{listers.New[*v1beta1.OpenstackVolumePopulator](indexer, v1beta1.Resource("openstackvolumepopulator"))}
}

// OpenstackVolumePopulators returns an object that can list and get OpenstackVolumePopulators.
func (s *openstackVolumePopulatorLister) OpenstackVolumePopulators(namespace string) OpenstackVolumePopulatorNamespaceLister {
	return openstackVolumePopulatorNamespaceLister{listers.NewNamespaced[*v1beta1.OpenstackVolumePopulator](s.ResourceIndexer, namespace)}
}

// OpenstackVolumePopulatorNamespaceLister helps list and get OpenstackVolumePopulators.
// All objects returned here must be treated as read-only.
type OpenstackVolumePopulatorNamespaceLister interface {
	// List lists all OpenstackVolumePopulators in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta1.OpenstackVolumePopulator, err error)
	// Get retrieves the OpenstackVolumePopulator from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1beta1.OpenstackVolumePopulator, error)
	OpenstackVolumePopulatorNamespaceListerExpansion
}

// openstackVolumePopulatorNamespaceLister implements the OpenstackVolumePopulatorNamespaceLister
// interface.
type openstackVolumePopulatorNamespaceLister struct {
	listers.ResourceIndexer[*v1beta1.OpenstackVolumePopulator]
}
